About Perforce and P4OFC

Perforce is a software configuration management tool. The documents managed by Perforce reside in a depot. To work on documents, you open and edit them in your client workspace. When you're done, you check in changed documents, using the Perforce menu options. The depot keeps track of all the current and previous revisions of a file.

P4OFC provides the Perforce menu, which allows you to manage multiple revisions of the following types of Microsoft® Office documents:

  • Microsoft® Word

  • Microsoft® Excel

  • Microsoft® PowerPoint

If you would like more information about Perforce, see the Perforce User's Guide, which can be found at www.perforce.com.


Getting started with Perforce

To start using Perforce, you need to configure your client computer to access the Perforce server. For more information, see the Perforce User's Guide.

P4OFC offers access to a number of Perforce commands from a Microsoft® Office document. Use the Perforce menu to:

  • Add documents to the Perforce depot.

  • Check documents into and out of the Perforce depot.

  • Compare different versions of a document.

  • Lock a document while you have it checked out, preventing others from modifying it.

  • Undo or revert your add or check out.

  • View detailed Perforce and document information, including revision history, document status, and connection information.

To learn more about these commands, see the Perforce menu overview.

NOTE: P4OFC cannot copy (sync) depot files to your computer unless a version of that file already exists in your workspace. To sync files from the depot, you must use a Perforce client such as P4Win or the Perforce command-line.

To uninstall P4OFC, use Add/Remove Programs in the Windows Control Panel.


Getting more help

For more information about using Perforce, consult the following sources:

  • For information about using Perforce: See the Perforce User's Guide, available at our website: http://www.perforce.com/perforce/technical.html.

  • For information about maintaining your Perforce installation: Refer to the Perforce System Administrator's Guide.

If you cannot find the answers to your question in this help system, call (510) 864-7400 or send e-mail to support@perforce.com.

Please send any comments about Perforce technical documentation, including this help system, to manual@perforce.com.


Glossary

A
access level
atomic change transaction

B
base
binary file type
branch
branch specification
branch view

C
changelist
changelist form
changelist number
change review
checkpoint
client form
client name
client root
client side
client view
client workspace
codeline
conflict
counter

D
default changelist
default depot
deleted file
delta
depot
depot root
depot side
depot syntax
detached
diff

E
exclusionary access
exclusionary mapping

F
file conflict
file pattern
file repository
file revision
file tree
file type
fix
form
full-file storage

G
group

H
have list
head revision

I
integrate
Inter-File Branching

J
job
job specification
job view
journal
journaling

L
label
label view
lazy copy
license file
list access
local depot
local syntax
lock
log

M
mapping
MD5 checksum
merge
merge file
metadata
modification time

N
nonexistent revision
numbered changelist

O
open file
owner

P
P4
P4D
P4Diff
P4Win
pending changelist
Perforce server
protections

R
RCS format
read access
remote depot
reresolve
resolve
resource fork
reverse delta storage
revert
review access
review daemon
revision number
revision range
revision specification

S
server root
status
submit
subscribe
super access
symlink file type
sync

T
target file
text file type
theirs
three-way merge
tip revision
trigger
two-way merge
typemap

U
user

V
view

W
wildcard
write access

Y
yours


Perforce menu overview

The Perforce menu contains the following items:

  • Add to Perforce. Adds the document that you are currently working on to Perforce. For more information, see Adding documents to Perforce.

  • Check Out. Checks a document out of Perforce. For more information, see Checking documents out of Perforce.

  • Check In... Checks documents in to Perforce. For more information, see Checking documents in to Perforce.

  • Lock/Unlock document. Prevents other users from checking in the same file while you have it open.

  • Undo Add/Check Out. Discards any changes that you have made to the document in your workspace. P4OFC displays a prompt to ensure that this is what you want to do in Perforce. This operation is known as reverting a file.

  • Results of Last Command... Displays the results of last Perforce command that you performed.

  • Document Status... Displays the status of the current document, including the file name and path, as well as Perforce information.

  • Document History... Displays the current document's name and path, as well as the past revisions of the document, and the changelists associated with it. The Document History dialog contains document comparison options.

  • Checked-out Documents... Displays a list of all of the documents that you currently have checked out of Perforce.

  • Perforce Information... Displays your Perforce connection information. For more information about these fields, see the Perforce User's Guide, available at www.perforce.com.

  • Options... Enables you to set Perforce options. For more information on these options, see Changing Options in P4OFC.

  • Help... Displays the online help.

  • About P4OFC... Displays information about the version of P4OFC that you are running.


Adding documents to Perforce

To add a document to Perforce, the document that you want to add must be in your client workspace. If the document is not in your client workspace, P4OFC displays an error message and the document is not added.

  • To add a document to Perforce:

  1. Choose Perforce > Add to Perforce. If prompted to check the document into Perforce, enter in a description of your changes.

  2. Click Submit. P4OFC confirms that your document has been successfully added.

  3. Click OK.

For troubleshooting help, see Troubleshooting: Adding documents.


Checking documents out of Perforce

To work on a document that has been checked into Perforce, you must check the document out. There are two ways to check a document out of Perforce: automatically and manually.

When you open a document that is checked into Perforce, you are prompted to check the document out. To check the document out at this time, click OK.

If you click Cancel, the file opens in "Read-only" mode. You can edit this document, but you cannot save it (unless you use Save As... and specify a different file name). To edit and save a document that is in Perforce, you must first check it out.

To check a document out of Perforce:

  1. Open the document.

  2. Choose Perforce > Check Out.

For troubleshooting help, see Troubleshooting: Checking documents out.


Checking documents into Perforce

When you are finished working on a document that has been checked out of Perforce, you need to check it back in.

  • To check a document into Perforce:

  1. Choose Perforce > Check in... The Submit dialog is displayed.

  2. In the Description field, enter in a brief description of the work you have done on the document. Note that you must enter something into this field before submitting.

  3. Click Submit.

  4. If you are prompted to choose the documents that you want to check in, do so at this time. The document that you are working on is automatically selected. If available, you can choose other documents in this pane to check in at this time.

  5. If you want to check in your changes and immediately check the document out again (for example, to save an interim draft document), check Keep checked out.

  6. When you have finished selecting the documents that you want to check in, click Submit.

NOTE: Perforce jobs, which can be used to track work to be done, can be closed when you submit a document. To close jobs using P4OFC, you must either (1) set a jobview or (2) attach jobs to changelists. These tasks must be done outside of P4OFC; consult your Perforce administrator for details.


Changing options in P4OFC

Configuring P4OFC

To configure P4OFC, choose Perforce > Options. You have the following choices in that dialog:

Hide diff (compare versions) question dialog: By default, when you compare versions, a verification prompt tells you what action has been performed. To hide that prompt, enable this option

Display confirmation dialogs (on add/check out): By default, documents are automatically added or checked out without confirmation dialogs or results. To display confirmation dialogs and results, enable this option.

View other documents in changelist when checking in: By default, you can only check in the current document. To have the option of checking in all open documents at once, enable this option.

Automatically lock document when checking out: By default, documents are not locked when you check them out of Perforce. Other Perforce users can check the document out at the same time. To automatically lock a document whenever you check it out of Perforce, enable this option. You can always unlock the document by choosing Perforce > Unlock document.

Prompt to check in immediately after adding a document to Perforce: By default, after you add a document to Perforce you must manually check it in. To display a "Check in?" prompt immediately after you add a document, enable this option.

Prompt to check out when opening document: By default, you must choose Perforce > Check Out after opening a document. To automatically prompt for checkout, enable this option.

Prompt to check out when reopening document after undo (revert): by default, after undoing a checkout, you must choose Perforce >Check out. To automatically prompt for checkout after reverting a document, enable this option.

NOTE: Most of these options can also be configured through the "Do not show this dialog again" checkbox that is displayed on dialogs in P4OFC.


About comparing different versions of a document

Comparing different versions of a document

You can compare a Microsoft® Word document in your client workspace with any depot version of the document. You can also compare two versions of a file in the depot.

  • To compare your current document with the depot version, see Comparing workspace and depot versions.

  • To diff your current document with a previous version of the document in the depot, see Comparing workspace and previous versions.

  • To diff two depot versions of the document, see Comparing two previous versions.

NOTE: P4OFC uses the Microsoft Word "Track Changes" function for comparing documents (found under Tools > Track Changes). You can use this function to accept or delete changes to the file, after you have compared versions. For more information on this function, choose Help > Microsoft Word Help.


Comparing workspace and depot versions

You can compare your workspace version of a Microsoft® Word document to the current depot version by using the Perforce > Compare Versions... menu item.

  • To compare your current workspace version of the document to the depot version:

  1. Open the Microsoft Word document that you want to view.

  2. Choose Perforce > Compare Versions...

  3. If you have not saved your current version of the document, P4OFC prompts you do so. Click Yes to save your document. Microsoft Word displays the differences between the documents.

If you attempt to check in a document that contains differences, P4OFC reminds you that the file still contains results of the comparison. To remove the differences, choose Edit > Undo Compare Documents.


Comparing workspace and previous versions

You can compare your workspace version of a Microsoft® Word document to a previous version in the depot by choosing the Perforce > Document History... menu item.

  • To diff the current workspace version of a document against a previous version:

  1. Choose Perforce > Document History...

  2. Choose the version of the document to which you would like to compare your current document.

  3. Click Diff vs. Current. Microsoft Word displays the differences between the documents, if any. To display details about individual changes, mouse over the change.

If you attempt to check in a document that contains differences, P4OFC reminds you that the file still contains results of the comparison. To remove the differences, choose Edit > Undo Compare Documents.


Comparing two previous versions

Comparing workspace vs. depot version of your document

You can compare different depot versions of the same Microsoft® Word document, using the Perforce > Document History menu item.

  • To compare two different depot versions of a document:

  1. Open the Microsoft Word document that you want to view.

  2. Choose Perforce > Document History...

  3. Choose the two different versions of the file that you want to compare.

  4. Click Diff Revs.

P4OFC creates a document called Ver-[#]-vs-[#].doc, where # represents the version numbers of the document that you are comparing.


Adding documents

Troubleshooting: Adding documents

  • When I try to add a document to Perforce, I get an error stating that the document is not "under client's root." What does this mean?

To add a document to Perforce successfully, the document must be saved in your client workspace.

To add your document to Perforce, save it in your client workspace. If you do not know what this means, see your Perforce administrator.


Checking documents out

Troubleshooting: Checking documents out

  • When I try to check out a document from Perforce, I get an error stating that the "newest version in the Perforce depot (#) has been deleted." The error message tells me to use P4Win to recover the document. What does this mean?

The document that you are trying to check out has been deleted from Perforce. If you are familiar with Perforce, you can use P4Win or the Perforce command-line client to undo the delete. If you are not familiar with Perforce, contact your Perforce administrator.

You cannot access this document in Perforce until the document has been recovered.


Comparing documents

Troubleshooting: Comparing documents

  • I do not see the Perforce > Compare Versions menu option in Microsoft® PowerPoint or Microsoft® Excel. Why?

This function is only available for comparing Microsoft® Word documents. If you are in Microsoft PowerPoint or Microsoft Excel, you cannot compare versions.

  • After comparing my workspace version to the depot version of a document, I try to check the document in, but P4OFC tells me that there are "revisions from document comparison still active in the current document." What does this mean?

The differences between the two versions are still visible in your document. Deleted text is displayed as strike-through and added text is underlined. To remove these indicators, choose Undo > [last command].

  • After comparing two previous versions of the document, the Perforce > Check in menu option is grayed out. Why?

Comparing two previous versions creates a new document, called Ver-[#]-vs-[#].doc, where # represents the version numbers of the document that you are comparing. This document is not in Peforce, so you cannot check it in.

  • I displayed a checked-in document from P4Win and now cannot compare it with a previous revision. How do I do this?

In P4Win, under settings for File>View/Edit, add "doc" to the "Don't use temp files for these extensions" field.


glossary001

 A permission assigned to a user to control which Perforce commands the user can execute.


glossary002

 The grouping of operations that affect multiple files into a single transaction. If all operations in the transaction succeed, all the files are updated. If any operation in the transaction fails, none of the files are updated.


glossary003

 The file revision that two newer, conflicting file revisions were commonly based on.


glossary004

 A non-text file.


glossary005

 (noun) A codeline created by copying another codeline, as opposed to a codeline that was created by adding original files.

(verb) To create a codeline by integrating files.


glossary006

 The Perforce form you use to modify a branch.


glossary007

 A specification of the branching relationship between two codelines in the depot. Each branch view has a unique name, and defines how files are mapped from the originating codeline to the target codeline.


glossary008

 The process of sending email to users who have registered their interest in changes made to specified files in the depot.


glossary009

 An atomic change transaction in Perforce. The changes specified in the changelist are not stored in the depot until the changelist is submitted to the depot.


glossary010

 The Perforce form you use to modify a changelist.


glossary011

 The unique numeric identifier of a changelist.


glossary012

 A copy of the underlying server metadata at a particular moment in time.


glossary013

 The Perforce form you use to define a client workspace.


glossary014

 A name that uniquely identifies the current client workspace.


glossary015

 The root directory of a client workspace.


glossary016

 The right-hand side of a mapping within a client view, specifying where the corresponding depot files are located in the client workspace.


glossary017

 A set of mappings that specifies the correspondence between file locations in the depot and the client workspace.


glossary018

 Directories on the client computer where you work on file revisions that are managed by Perforce. By default this name is set to the name of the host machine on which the client workspace is located. to override the default name, set the P4CLIENT environment variable. Client workspaces, labels and branch specifications cannot share the same name.


glossary019

 A set of files that evolve collectively. One codeline can be branched from another, allowing each set of files to evolve separately.


glossary020

 One type of conflict occurs when two users open a file for edit. One user submits the file; after which the other user can't submit because of a conflict. The cause of this type of conflict is two users opening the same file.

The other type of conflict is when users try to merge one file into another. This type of conflict occurs when the comparison of two files to a common base yields different results, indicating that the files have been changed in different ways. In this case, the merge can't be done automatically and must be done by hand.


glossary021

 A numeric variable used by Perforce to track changelist numbers in conjunction with the review feature.


glossary022

 The changelist used by Perforce commands, unless a numbered changelist is specified.


glossary023

 The depot name that is assumed when no name is specified. The default depot name is "depot."


glossary024

 In Perforce, a file with its head revision marked as deleted. Older revisions of the file are still available.


glossary025

 The differences between two files.


glossary026

 A file repository on the Perforce server. It contains all versions of all files ever submitted to the server. There can be multiple depots on a single server.


glossary027

 The left side of any client view mapping, specifying the location of files in a depot.


glossary028

 The root directory for a depot.


glossary029

 Perforce syntax for specifying the location of files in the depot.


glossary030

 A client computer that is not connected to a Perforce server.


glossary031

 A set of lines that don't match when two files are compared (whereas a conflict is a pair of unequal diffs between each of two files and a common third file).


glossary032

 A permission that denies access to the specified files.


glossary033

 A view mapping that excludes specific files.


glossary034

 In a three-way file merge, a situation in which two revisions of a file differ from each other and from their base file.
Also: the result of an attempt to submit a file that is not an edit of the head revision of the file in the depot, which typically occurs when another user opens the file for edit after you have opened the file for edit.


glossary035

 Perforce command line syntax that enables you to specify files using wildcards.


glossary036

 The master copy of all files; shared by all users. In Perforce, this is called the depot.


glossary037

 A specific version of a file within the depot. Each revision is assigned a number, in sequence. Any revision can be accessed in the depot by its revision number, for example: testfile#3.


glossary038

 All the subdirectories and files under a given root directory.


glossary039

 An attribute that determines how Perforce stores and diffs a particular file. Examples of file types are text and binary.


glossary040

 A job that has been linked to a changelist.


glossary041

 Screens displayed by certain Perforce commands. For example, you use the Perforce change form to enter comments about a particular changelist and to verify the affected files.


glossary042

 The method by which Perforce stores revisions of binary files in the depot: every file revision is stored in full. Contrast this with reverse delta storage, which Perforce uses for text files.


glossary043

 A list of Perforce users.


glossary044

 The list of file revisions currently in the client workspace.


glossary045

 The most recent revision of a file within the depot. Since file revisions are numbered sequentially, this will also be the highest-numbered revision of that file.


glossary046

 To compare two sets of files (two codeline branches) and determine which changes in one set are applicable to the other; determine whether those changes have already been propagated; and propagate outstanding changes.


glossary047

 Perforce's proprietary branching mechanism.


glossary048

 A user-defined unit of work tracked by Perforce. The job template determines what information is tracked. The template can be modified by the Perforce system administrator.


glossary049

 A specification containing the fields and valid values stored for a Perforce job.


glossary050

 A string used to find jobs that match particular criteria.


glossary052

 A file containing a record of every change made to the Perforce server's metadata since the time of the last checkpoint.


glossary053

 The process of recording changes made to the Perforce server's metadata.


glossary054

 A named list of user-specified file revisions.


glossary055

 The view that specifies which file names in the depot can be stored in a particular label.


glossary056

 A method used by Perforce to make internal copies of files without duplicating file content in the depot. Lazy copies minimize the consumption of disk space by storing references to the original file instead of copies of the file.


glossary057

 Ensures that the number of Perforce users on your site does not exceed the number for which you have paid.


glossary058

 A protection level that enables you to run reporting commands but prevents access to the contents of files.


glossary059

 Any depot located on the current Perforce server.


glossary060

 The operating-system-specific syntax for specifying a file name.


glossary061

 A Perforce file lock prevents other clients from submitting the locked file.


glossary062

 Error output from the Perforce server. By default, error output is written to standard error. To specify a log file, set the P4LOG environment variable, or use the p4d -L flag.


glossary063

 A single line in a view, consisting of a left side and a right side that specify the correspondences between files in the depot and files in a client, label, or branch. The left side specifies the depot file and the right side specifies the client files.


glossary064

 The method used by Perforce to verify the integrity of archived files.


glossary065

 The process of combining the contents of two conflicting file revisions into a single file.


glossary066

 A file generated by Perforce from two conflicting file revisions.


glossary067

 The data stored by the Perforce server that describes the files in the depot, the current state of client workspaces, protections, users, clients, labels, and branches. Metadata includes all the data stored in the server except for the actual contents of the files.


glossary068

 The time a file was last changed.


glossary069

 A completely empty revision of any file. Syncing to a nonexistent revision of a file removes it from your workspace. An empty file revision created by 'p4 delete' and the #none revision specifier are examples of nonexistent file revisions.


glossary070

 A pending changelist to which Perforce has assigned a number.


glossary071

 A file that you are changing in your client workspace.


glossary072

 The Perforce user who created a particular client, branch, or label.


glossary073

 The Perforce command line interface program, and the command you issue to execute Perforce commands from the operating system command line.


glossary074

 The program on the Perforce server that manages the depot and the metadata.


glossary075

 The Perforce GUI application that compares two files.


glossary076

 The Perforce Windows GUI client program.


glossary077

 A changelist that has not been submitted.


glossary078

 The Perforce depot and metadata on a central host. Also the program that manages the depot and metadata.


glossary079

 The permissions stored in the Perforce server's protections table.


glossary080

 Revision Control System format. Used for storing revisions of text files. RCS format uses reverse delta encoding for file storage. Perforce uses RCS format to store text files.


glossary081

 A protection level that enables you to read the contents of files managed by Perforce.


glossary082

 A depot located on a server other than the current Perforce server.


glossary083

 The process of resolving a file after the file is resolved and before it is submitted


glossary084

 The process you use to reconcile the differences between two revisions of a file.


glossary085

 One fork of a Macintosh file. (Macintosh files are composed of a resource fork and a data fork.) You can store resource forks in Perforce depots as part of an AppleSingle file by using Perforce's apple file type. (In pre-99.2 Perforce, use the resource file type).


glossary086

 The method that Perforce uses to store revisions of text files. Perforce stores the changes between each revision and its previous revision, plus the full text of the head revision.


glossary087

 To discard the changes you have made to a file in the client workspace.


glossary088

 A special protections level that includes read and list accesses, and grants permission to run the review command.


glossary089

 Any daemon process that uses the p4 review command.


glossary090

 A number indicating which revision of the file is being referred to.


glossary100

 A range of revision numbers for a specified file, specified as the low and high end of the range. For example, myfile#5,7 specifies revisions 5 through 7 of a file called "myfile"..


glossary101

 A suffix to a filename that specifies a particular revision of that file. Revision specifiers can be revision numbers, change numbers, label names, date/time specifications, or client names.


glossary102

 The directory in which the server program stores its metadata and all the shared files. To specify the server root, set the P4ROOT environment variable.


glossary103

 For a changelist, a value that indicates whether the changelist is new, pending or submitted. For a job, a value that indicates whether the job is open, closed, or suspended. You can customize job statuses.


glossary104

 To send a pending changelist and changed files to the Perforce server for processing.


glossary105

 To register to receive email whenever changelists that affect particular files are submitted.


glossary106

 An access level that gives the user permission to run every Perforce command, including commands that set protections, obliterate files, verify files with an MD5 signature, and set up connections to remote depots.


glossary107

 Perforce file type assigned to symbolic links.


glossary108

 To copy a file revision (or set of file revisions) from the depot to a client workspace.


glossary109

 The file that receives the changes when you are integrating changes between a branched codeline and the original codeline.


glossary110

 A file that contains only ASCII text.


glossary111

 When you resolve a file conflict, the revision in the depot with which the client file is merged. When you are working with branched files, theirs is the donor file.


glossary112

 The process of combining three file revisions. During a three-way merge, you can identify where conflicting changes have occurred and specify how you want to resolve the conflicts.


glossary113

 In Perforce, the head revision. Tip revision is a term used by some other SCM systems.


glossary114

 A script automatically invoked by the Perforce server when changelists are submitted.


glossary115

 The process of combining two file revisions. In a two-way merge, you can see differences between the files but cannot see conflicts.


glossary116

 A Perforce table in which you assign Perforce file types to files.


glossary117

 The identifier that Perforce uses to determine who is performing an operation.


glossary118

 A description of the relationship between two sets of files.


glossary119

 A special character used to match other characters in strings. Perforce wildcards are:

* matches anything except a slash

... matches anything including slashes

%d used for parameter substitution in views.


glossary120

 A protection level that enables you to run commands that alter the contents of files in the depot. Write access includes read and list accesses.


glossary121

 The edited version of a file in the client workspace, when you resolve a file. Also, the target file when you integrate a branched file.